# Empire State Run Up

[![Downloads](https://static.pepy.tech/badge/EmpireStateRunUp)](https://pepy.tech/project/EmpireStateRunUp)

![empire_state_runup.png](images/empire_state_runup.png)

![ESRU browser](images/esru_browser.png)



Hello. I wrote an application to analyse the results of the 'Empire State Run Up', 2013 edition, after I ran the race. 

Here you will find my code.

## If you just want to install it

See the previous section called 'Packaging', and then install it on your virtual environment:

```shell
python3 -m venv ~/virtualenv/EmpireStateRunUp
. ~/virtualenv/EmpireStateRunUp/bin/activate
pip install --upgrade pip
pip install --upgrade build
pip install --upgrade wheel
python -m build .
pip install --upgrade dist/EmpireStateRunUp-0.0.1-py3-none-any.whl
```

There are 4 scripts that you can run:

* esru_numbers
* esru_outlier
* esru_browser
* esru_plot

If you want to learn more about these programs, please grab a cup of coffe and read the [TUTORIAL](TUTORIAL.md)

## If you are a developer

### Running the code in developer mode

```shell
python3 -m venv ~/virtualenv/EmpireStateRunUp
. ~/virtualenv/EmpireStateRunUp/bin/activate
pip install --upgrade pip
pip install --upgrade build
pip install --upgrade wheel
pip install --editable .
```

#### Modifying the layout without restarting the apps

For example, playing with the 'esru_outlier' application:

```shell
. ~/virtualenv/EmpireStateRunUp/bin/activate
pip install textual-dev
# On another terminal: . ~/virtualenv/EmpireStateRunUp/bin/activate && textual console
textual run --dev empirestaterunup.apps:run_outlier 
```

### Packaging 

```shell
python3 -m venv ~/virtualenv/EmpireStateRunUp
. ~/virtualenv/EmpireStateRunUp/bin/activate
pip install --upgrade pip
pip install --upgrade build
pip install --upgrade wheel
python -m build .
```

### Installation from PiPy

For your user:
```shell
pip install --user EmpireStateRunUp
```

Or using a virtual environment:

```shell
python -m venv ~/virtualenv/EmpireStateRunUp && \
.  ~/virtualenv/EmpireStateRunUp/bin/acvtivate && \
pip install EmpireStateRunUp
```

#### Country codes

I used the files generated by the [ISO-3166-Countries-with-Regional-Codes
](https://github.com/lukes/ISO-3166-Countries-with-Regional-Codes/tree/master) for the flag lookup, using [Regional indicator symbol](https://en.wikipedia.org/wiki/Regional_indicator_symbol).

## Tutorial

Make sure you check the [tutorial](TUTORIAL.md). It explains how this project got started, as well showcases features of the applications.

## Spin off this as a separate project?

If there is enough interest I may spin this off a separate project. Also, if you see a bug please open an Issue and I will work on a fix.

